vif-route-qubes 6.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202
  1. #!/bin/bash
  2. #============================================================================
  3. # /etc/xen/vif-route-qubes
  4. #
  5. # Script for configuring a vif in routed mode.
  6. # The hotplugging system will call this script if it is specified either in
  7. # the device configuration given to Xend, or the default Xend configuration
  8. # in /etc/xen/xend-config.sxp. If the script is specified in neither of those
  9. # places, then vif-bridge is the default.
  10. #
  11. # Usage:
  12. # vif-route (add|remove|online|offline)
  13. #
  14. # Environment vars:
  15. # vif vif interface name (required).
  16. # XENBUS_PATH path to this device's details in the XenStore (required).
  17. #
  18. # Read from the store:
  19. # ip list of IP networks for the vif, space-separated (default given in
  20. # this script).
  21. #============================================================================
  22. dir=$(dirname "$0")
  23. # shellcheck disable=SC1091,SC1090
  24. . "$dir/vif-common.sh"
  25. set -o pipefail
  26. #main_ip=$(dom0_ip)
  27. # Network Hooks for triggering supplementary actions on AppVM connect
  28. network_hooks() {
  29. local command="$1"
  30. local vif="$2"
  31. local addr="$3"
  32. local vif_type
  33. vif_type="$(xenstore-read "${XENBUS_PATH}/type")"
  34. if [ -d /rw/config/network-hooks.d ]; then
  35. for hook in /rw/config/network-hooks.d/*
  36. do
  37. if [ -x "$hook" ]; then
  38. log debug "Executing network-hook $(basename "$hook")..."
  39. do_without_error "${hook}" "${command}" "${vif}" "${vif_type}" "${addr}"
  40. fi
  41. done
  42. fi
  43. }
  44. conntrack_purge () {
  45. local n output deleted msg
  46. n='(0|[1-9][0-9]*)' msg='flow entries have been deleted\.$'
  47. deleted="^conntrack v$n\\.$n\\.$n \\(conntrack-tools\\): $n $msg"
  48. output=$(LC_ALL=C exec conntrack -D "$@" 2>&1 >/dev/null) || :
  49. [[ "$output" =~ $deleted ]]
  50. }
  51. ipt_arg=
  52. if "iptables-restore" --help 2>&1 | grep -q wait=; then
  53. # 'wait' must be last on command line if secs not specified
  54. ipt_arg=--wait
  55. fi
  56. # shellcheck disable=SC2154
  57. if [ "${ip}" ]; then
  58. # get first IPv4 and first IPv6
  59. for addr in ${ip}; do
  60. if [ -z "$ip4" ] && [[ "$addr" = *.* ]]; then
  61. ip4="$addr"
  62. elif [ -z "$ip6" ] && [[ "$addr" = *:* ]]; then
  63. ip6="$addr"
  64. fi
  65. done
  66. # IPs as seen by this VM
  67. netvm_ip="$ip4"
  68. netvm_gw_ip=$(qubesdb-read /qubes-netvm-gateway)
  69. netvm_gw_ip6=$(qubesdb-read /qubes-netvm-gateway6 || :)
  70. netvm_dns1_ip=$(qubesdb-read /qubes-netvm-primary-dns)
  71. netvm_dns2_ip=$(qubesdb-read /qubes-netvm-secondary-dns)
  72. back_ip="$netvm_gw_ip"
  73. back_ip6="$netvm_gw_ip6"
  74. # IPs as seen by the VM - if other than $netvm_ip
  75. appvm_gw_ip="$(qubesdb-read "/mapped-ip/$ip4/visible-gateway" 2>/dev/null || :)"
  76. appvm_ip="$(qubesdb-read "/mapped-ip/$ip4/visible-ip" 2>/dev/null || :)"
  77. fi
  78. readonly max_domid=32752
  79. # if domid is 0 something is seriously wrong, so don’t check for that case
  80. if ! [[ $vif =~ ^vif([1-9][0-9]{,4})\.(0|[1-9][0-9]*)$ ]]; then
  81. printf 'Bad interface name %q\n' "$vif">&2
  82. exit 1
  83. fi
  84. domid=${BASH_REMATCH[1]} sub=${BASH_REMATCH[2]}
  85. # metric must be positive, but prefer later interface
  86. # 32752 is max XID aka domid
  87. if (( domid > max_domid )); then
  88. printf %s\\n "domid $domid too large"
  89. exit 1
  90. fi
  91. metric=$(( max_domid - domid ))
  92. # shellcheck disable=SC2154
  93. case "$command" in
  94. online)
  95. echo 1 >"/proc/sys/net/ipv4/conf/${vif}/proxy_arp"
  96. ipcmd='add'
  97. iptables_cmd='-I PREROUTING 1'
  98. cmdprefix=''
  99. ipv6_disabled=$(cat /proc/sys/net/ipv6/conf/"${vif}"/disable_ipv6 || echo 1)
  100. # without a MAC address we will fail later with a confusing error
  101. mac=$(xenstore-read "backend/vif/$domid/$sub/mac") || exit 1
  102. ;;
  103. offline)
  104. do_without_error ifdown "${vif}"
  105. ipcmd='del'
  106. iptables_cmd='-D PREROUTING'
  107. cmdprefix='do_without_error'
  108. # cleanup IPv6 config even if _now_ it is disabled
  109. ipv6_disabled=0
  110. ;;
  111. esac
  112. # Apply NAT if IP visible from the VM is different than the "real" one
  113. # See vif-qubes-nat.sh for details
  114. # XXX: supported only for the first IPv4 address, IPv6 is dropped if this
  115. # feature is enabled
  116. if [ -n "$appvm_ip" ] && [ -n "$appvm_gw_ip" ] && [ "$appvm_ip" != "$netvm_ip" ]; then
  117. # shellcheck source=network/vif-qubes-nat.sh
  118. . "$dir/vif-qubes-nat.sh"
  119. fi
  120. case $- in
  121. (*e*) :;;
  122. (*) echo '-e not set'>&2; exit 1;;
  123. esac
  124. # add anti-spoofing rules before enabling the interface
  125. if [ "${ip}" ]; then
  126. # If we’ve been given a list of IP addresses, then add routes from us to
  127. # the VMs we serve using those addresses.
  128. for addr in ${ip};
  129. do
  130. if [[ "$addr" = *:* ]]; then
  131. ipt=ip6tables-restore
  132. else
  133. ipt=iptables-restore
  134. fi
  135. printf '%s\n' "*raw" \
  136. "$iptables_cmd -i ${vif} ! -s ${addr} -j DROP" \
  137. "$iptables_cmd ! -i vif+ -s ${addr} -j DROP" \
  138. "COMMIT" |
  139. ${cmdprefix} "$ipt" --noflush $ipt_arg
  140. if [[ "$command" = 'online' ]]; then
  141. ip -- neighbour "${ipcmd}" to "${addr}" \
  142. dev "${vif}" lladdr "$mac" nud permanent
  143. fi
  144. if ! conntrack_purge -s "$addr" || ! conntrack_purge -d "$addr"; then
  145. printf 'Cannot purge stale conntrack entries for %q\n' "$addr">&2
  146. exit 1
  147. fi
  148. done
  149. # if no IPv6 is assigned, block all IPv6 traffic on that interface
  150. if ! [[ "$ip" = *:* ]]; then
  151. echo -e "*raw\\n$iptables_cmd -i ${vif} -j DROP\\nCOMMIT" |
  152. ${cmdprefix} ip6tables-restore --noflush $ipt_arg
  153. fi
  154. fi
  155. if [ "$command" = "online" ]; then
  156. ifconfig "${vif}" up
  157. fi
  158. if [ "${ip}" ]; then
  159. # If we've been given a list of IP addresses, then add routes from dom0 to
  160. # the guest using those addresses.
  161. for addr in ${ip};
  162. do
  163. if [[ "$addr" = *:* ]] && [[ "$ipv6_disabled" = 1 ]]; then
  164. log error "Cannot set IPv6 route to ${addr}, IPv6 disabled in the kernel"
  165. continue
  166. fi
  167. ${cmdprefix} ip route "${ipcmd}" "${addr}" dev "${vif}" metric "$metric"
  168. network_hooks "${command}" "${vif}" "${addr}"
  169. done
  170. ${cmdprefix} ip addr "${ipcmd}" "${back_ip}/32" dev "${vif}"
  171. if [ "${back_ip6}" ] && [[ "${back_ip6}" != "fe80:"* ]] && [[ "$ipv6_disabled" != 1 ]]; then
  172. ${cmdprefix} ip addr "${ipcmd}" "${back_ip6}/128" dev "${vif}"
  173. fi
  174. else
  175. network_hooks "${command}" "${vif}"
  176. fi
  177. log debug "Successful vif-route-qubes $command for $vif."
  178. if [ "$command" = "online" ]; then
  179. success
  180. fi